
SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for vit_attachment
-- ----------------------------
DROP TABLE IF EXISTS `vit_attachment`;
CREATE TABLE `vit_attachment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL COMMENT '用户id',
  `session` varchar(50) DEFAULT NULL COMMENT '用户登录session名称',
  `storage_id` int(11) DEFAULT NULL COMMENT '储存配置信息id',
  `filename` varchar(255) NOT NULL COMMENT '文件名',
  `fileurl` varchar(255) NOT NULL COMMENT '文件地址',
  `type` varchar(255) NOT NULL COMMENT '类型1图片2音频3视频',
  `storage` int(2) DEFAULT NULL COMMENT '1本地2七牛3腾讯云4阿里云5FTP',
  `createtime` int(11) NOT NULL COMMENT '上传时间',
  `size` int(11) DEFAULT '0' COMMENT '时长',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for vit_auth_map
-- ----------------------------
DROP TABLE IF EXISTS `vit_auth_map`;
CREATE TABLE `vit_auth_map` (
  `admin_id` int(11) NOT NULL COMMENT '用户ID',
  `role_id` int(11) NOT NULL COMMENT '角色ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户角色对应关系表';


-- ----------------------------
-- Table structure for vit_auth_nodes
-- ----------------------------
DROP TABLE IF EXISTS `vit_auth_nodes`;
CREATE TABLE `vit_auth_nodes` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(20) unsigned DEFAULT '0' COMMENT '用户id',
  `rule_id` int(11) DEFAULT NULL COMMENT '角色id',
  `node` varchar(200) DEFAULT '' COMMENT '节点',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `idx_system_auth_auth` (`uid`) USING BTREE,
  KEY `idx_system_auth_node` (`node`(191)) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='系统-授权';

-- ----------------------------
-- Table structure for vit_menu
-- ----------------------------
DROP TABLE IF EXISTS `vit_menu`;
CREATE TABLE `vit_menu` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `site_id` int(11) DEFAULT NULL,
  `type` varchar(20) DEFAULT NULL COMMENT '归属应用',
  `title` varchar(20) NOT NULL COMMENT '菜单名称',
  `url` varchar(255) NOT NULL COMMENT '菜单链接',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '菜单图标',
  `pid` int(11) NOT NULL COMMENT '上级节点ID',
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '排序',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT '启用状态',
  `open` tinyint(1) DEFAULT '0' COMMENT '是否新窗口打开 0否 1是',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='系统菜单表';

-- ----------------------------
-- Records of vit_menu
-- ----------------------------
INSERT INTO `vit_menu` VALUES ('1', null, 'admin', '首页', 'admin/index/index', 'viticon vit-icon-zhuye', '0', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('2', null, 'admin', '菜单设置', 'admin/menu/index', 'viticon vit-icon-caidan', '0', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('3', null, 'admin', '权限设置', 'admin/role/index', 'viticon vit-icon-vip', '0', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('4', null, 'admin', '用户管理', 'admin/user/index', 'viticon vit-icon-user', '0', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('5', null, 'admin', '系统管理', '#', 'viticon vit-icon-zhuomian', '0', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('6', null, 'admin', '站点设置', 'admin/system/site', 'viticon vit-icon-diqiu', '5', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('7', null, 'admin', '文章管理', 'admin/news/index', 'viticon vit-icon-bianji', '5', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('8', null, 'admin', '系统设置', 'admin/system/setup', 'viticon vit-icon-shezhi1', '5', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('9', null, 'admin', '系统日志', 'admin/system/log', 'viticon vit-icon-shijian', '5', '50', '1', '0');
INSERT INTO `vit_menu` VALUES ('10', null, 'admin', '系统更新', 'admin/system/info', 'viticon vit-icon-fasong', '5', '50', '1', null);
INSERT INTO `vit_menu` VALUES ('11', null, 'index', '首页', '/', 'viticon vit-icon-jingyin', '0', '50', '1', null);


-- ----------------------------
-- Table structure for vit_news
-- ----------------------------
DROP TABLE IF EXISTS `vit_news`;
CREATE TABLE `vit_news` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tid` int(10) unsigned NOT NULL COMMENT '分类id',
  `title` varchar(100) NOT NULL,
  `cover` varchar(100) NOT NULL COMMENT '封面图片',
  `content` mediumtext NOT NULL,
  `author` varchar(50) NOT NULL,
  `is_display` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示0显示1不显示',
  `createtime` int(10) unsigned NOT NULL,
  `pv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '访问量',
  PRIMARY KEY (`id`),
  KEY `title` (`title`),
  KEY `cateid` (`tid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of vit_news
-- ----------------------------
INSERT INTO `vit_news` VALUES ('1', '1', 'VitPhp管理系统使用教程', '/static/theme/images/minilogo.png', '<p>欢迎使用VitPhp多应用管理系统，接下来我们了解一下系统的基本功能。</p><p>首页：查看系统数据，配置系统公告。</p><p>平台管理：创建项目平台，管理员可以自由分配到期时间和分配用户项目，</p><p>应用管理：可以安装已开发的应用，编辑卸载删除。</p><p>菜单管理，配置后台菜单。</p><p>权限管理：创建用户权限组，自由分配权限。</p><p>用户管理：管理系统用户，可以给用户分配权限和权限组。</p><p>站点设置：配置网站基础信息，每个用户可以设置域名和域名下的参数，当访问该域名时可以显示该域名下的配置。</p><p>文章管理：设置文章，可在主页显示，或者配置公告列表。</p><p>系统设置：创始人权限，配置框架主要信息，可以设置微信登录配置，远程附件配置。</p><p>系统更新：如果系统框架有更新时，可以在后台一键升级版本来体验最新功能。</p>', 'admin', '0', '1655249746', '4247');

-- ----------------------------
-- Table structure for vit_news_type
-- ----------------------------
DROP TABLE IF EXISTS `vit_news_type`;
CREATE TABLE `vit_news_type` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(30) NOT NULL COMMENT '分类名称',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for vit_qrcode
-- ----------------------------
DROP TABLE IF EXISTS `vit_qrcode`;
CREATE TABLE `vit_qrcode` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sid` varchar(16) DEFAULT NULL,
  `weid` int(11) DEFAULT NULL,
  `openid` varchar(50) DEFAULT NULL,
  `avatar` varchar(255) DEFAULT NULL,
  `mobile` varchar(11) DEFAULT NULL,
  `nickname` varchar(150) DEFAULT NULL,
  `createtime` varchar(11) DEFAULT NULL,
  `is_login` tinyint(2) DEFAULT '0' COMMENT '是否登录成功  1登录成功 2扫码成功',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of vit_news_type
-- ----------------------------
INSERT INTO `vit_news_type` VALUES ('1', '使用教程');

-- ----------------------------
-- Table structure for vit_role
-- ----------------------------
DROP TABLE IF EXISTS `vit_role`;
CREATE TABLE `vit_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `title` varchar(20) NOT NULL COMMENT '名称',
  `desc` varchar(255) DEFAULT NULL COMMENT '介绍',
  `status` tinyint(4) NOT NULL DEFAULT '1',
  `create_time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='角色权限集';

-- ----------------------------
-- Table structure for vit_settings
-- ----------------------------
DROP TABLE IF EXISTS `vit_settings`;
CREATE TABLE `vit_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `addons` varchar(255) DEFAULT NULL COMMENT '类型(模块名)',
  `name` varchar(255) DEFAULT NULL,
  `value` mediumtext COMMENT '内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of vit_settings
-- ----------------------------
INSERT INTO `vit_settings` VALUES ('1', 'setup', 'is_reg', '1');
INSERT INTO `vit_settings` VALUES ('2', 'setup', 'interest', '1');
INSERT INTO `vit_settings` VALUES ('3', 'setup', 'imgwidth', '800');
INSERT INTO `vit_settings` VALUES ('4', 'setup', 'imgtype', 'jpg,jpeg,gif,png');
INSERT INTO `vit_settings` VALUES ('5', 'setup', 'mp3type', 'mp3');
INSERT INTO `vit_settings` VALUES ('6', 'setup', 'mp4type', 'mp4');
INSERT INTO `vit_settings` VALUES ('66', 'setup', 'atta_type', '1');

-- ----------------------------
-- Table structure for vit_storage_setup
-- ----------------------------
DROP TABLE IF EXISTS `vit_storage_setup`;
CREATE TABLE `vit_storage_setup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `type` int(2) DEFAULT NULL COMMENT '1本地2七牛3腾讯云4阿里云5FTP',
  `addons` varchar(50) DEFAULT NULL COMMENT '应用标识',
  `note` varchar(255) DEFAULT NULL COMMENT '其他备注',
  `access_key` varchar(100) DEFAULT NULL COMMENT '七牛access_key',
  `secret_key` varchar(100) DEFAULT NULL COMMENT '七牛secret_key',
  `space` varchar(50) DEFAULT NULL COMMENT '七牛空间名称',
  `domain` varchar(100) DEFAULT NULL COMMENT '七牛域名',
  `tx_region` varchar(50) DEFAULT NULL COMMENT '腾讯云访问地址',
  `tx_accesskey` varchar(100) DEFAULT NULL COMMENT '腾讯accesskey',
  `tx_secretkey` varchar(100) DEFAULT NULL COMMENT '腾讯secretkey',
  `tx_space` varchar(50) DEFAULT NULL COMMENT '腾讯储存名称',
  `tx_domain` varchar(100) DEFAULT NULL COMMENT '腾讯云域名',
  `al_region` varchar(50) DEFAULT NULL COMMENT '阿里云访问地址',
  `al_accesskey` varchar(100) DEFAULT NULL COMMENT '阿里云accesskey',
  `al_secretkey` varchar(100) DEFAULT NULL COMMENT '阿里云secretkey',
  `al_intranet` varchar(50) DEFAULT NULL COMMENT '内网上传1关闭2开启',
  `al_space` varchar(50) DEFAULT NULL COMMENT '阿里云空间名称',
  `al_domain` varchar(100) DEFAULT NULL COMMENT '阿里云域名',
  `ftp_ip` varchar(50) DEFAULT NULL COMMENT 'FTP IP地址',
  `ftp_port` varchar(10) DEFAULT NULL COMMENT 'FTP端口',
  `ftp_account` varchar(100) DEFAULT NULL COMMENT 'FTP用户名',
  `ftp_pass` varchar(100) DEFAULT NULL COMMENT 'FTP密码',
  `ftp_path` varchar(100) DEFAULT NULL COMMENT 'FTP储存路径',
  `ftp_domain` varchar(100) DEFAULT NULL COMMENT 'FTP访问域名',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for vit_sys_log
-- ----------------------------
DROP TABLE IF EXISTS `vit_sys_log`;
CREATE TABLE `vit_sys_log` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_name` varchar(255) DEFAULT NULL,
  `auth` varchar(255) DEFAULT NULL,
  `auth_text` varchar(500) DEFAULT NULL,
  `description` text,
  `ip` varchar(15) DEFAULT NULL,
  `create_time` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for vit_system_site
-- ----------------------------
DROP TABLE IF EXISTS `vit_system_site`;
CREATE TABLE `vit_system_site` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `domain` varchar(50) DEFAULT NULL COMMENT '域名',
  `name` varchar(50) DEFAULT NULL COMMENT '网站名称',
  `title` varchar(255) DEFAULT NULL COMMENT '网站标题',
  `keywords` varchar(255) DEFAULT NULL COMMENT '网站关键字',
  `description` varchar(255) DEFAULT NULL COMMENT '网站描述',
  `favicon` varchar(255) DEFAULT NULL,
  `index_logo` varchar(255) DEFAULT NULL COMMENT '首页logo',
  `admin_logo` varchar(255) DEFAULT NULL COMMENT '后台logo',
  `kf_qq` varchar(100) DEFAULT NULL COMMENT '客服QQ',
  `index_content` mediumtext COMMENT '网站内容',
  `index_hdp` mediumtext COMMENT '幻灯片',
  `icpbeian` varchar(255) DEFAULT NULL,
  `foot_top` varchar(255) DEFAULT NULL COMMENT '底部文字（上）',
  `foot_bottom` varchar(255) DEFAULT NULL COMMENT '底部文字（下）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of vit_system_site
-- ----------------------------
INSERT INTO `vit_system_site` VALUES ('1', 'www.vitphp.cn', 'vitphp', 'Vitphp多应用管理系统', 'Vitphp多应用管理系统 - 萌折科技', 'Vitphp多应用管理系统 - 萌折科技', null, '', '', '', '<p><br></p>', '', '', 'Copyright © 2022 vit-lite vitphp.cn All Rights Reserved', '免费开源的管理系统');

-- ----------------------------
-- Table structure for vit_users
-- ----------------------------
DROP TABLE IF EXISTS `vit_users`;
CREATE TABLE `vit_users` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `openid` varchar(50) DEFAULT NULL,
  `headimg` varchar(255) DEFAULT NULL COMMENT '头像',
  `username` varchar(25) NOT NULL COMMENT '用户名',
  `password` varchar(255) NOT NULL COMMENT '密码',
  `nickname` varchar(20) DEFAULT NULL COMMENT '姓名',
  `login_ip` varchar(20) DEFAULT NULL COMMENT '登录IP',
  `create_time` int(11) unsigned DEFAULT NULL COMMENT '创建时间',
  `login_num` int(11) DEFAULT '0' COMMENT '登录次数',
  `last_login` int(11) unsigned DEFAULT '0' COMMENT '上次登录时间',
  `is_deleted` int(11) DEFAULT '0' COMMENT '删除位',
  `sid` int(11) DEFAULT NULL COMMENT '上级id',
  `state` int(11) DEFAULT '1' COMMENT '启用状态',
  `pid` int(5) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='后台管理员表';
